#! /usr/bin/perl -w

BEGIN {
  unshift @INC, "..";
}

use Gtk2::TieScalar;

{
  my $data = Test->new();

  $data->set_data(42);

  my $var = 3;

  my $conn = Gtk2::TieScalar->create(\$var, $data, 'data');

  print "Data: ", $data->get_data(), " Var: $var\n";
  $var = 6;
  print "Data: ", $data->get_data(), " Var: $var\n";
  $data->set_data(84);
  print "Data: ", $data->get_data(), " Var: $var\n";
  $var = 2;
  print "Data: ", $data->get_data(), " Var: $var\n";
  $conn->destroy();
  print "Data: ", $data->get_data(), " Var: $var\n";
  $var = 27;
  print "Data: ", $data->get_data(), " Var: $var\n";
  $data->set_data(24);
  print "Data: ", $data->get_data(), " Var: $var\n";

  my $var2 = 2;
  my $conn2 = Gtk2::TieScalar->create(\$var2, $data, 'nofunc');
  ## This should fail
  $var2 = 38;
  print "Data: ", $data->get_data(), " Var: $var2\n";

}

package Test;

sub new {
  my $class = shift;

  return bless { DATA => 0 }, $class;
}

sub set_data {
  my $self = shift;
  my $val = shift;
  $self->{DATA} = $val;
}


sub get_data {
  my $self = shift;
  return $self->{DATA};
}



